<template>
	<div class="business-special-audit-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<vxe-grid v-bind="gridOptions" v-on="gridEvents" ref="gridRef" @checkbox-all="selectAllChangeEvent" @checkbox-change="selectChangeEvent">
				<template #form>
					<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline :disabled="gridOptions.loading">
						<el-form-item label="关键词" prop="Keyword">
							<el-input
								v-model.trim="state.queryParams.Keyword"
								placeholder="工单编码/标题"
								clearable
								@keyup.enter="handleQuery"
								class="keyword-input"
							/>
						</el-form-item>
						<el-form-item>
							<el-button type="primary" @click="handleQuery" :loading="gridOptions.loading">
								<SvgIcon name="ele-Search" class="mr5" />查询
							</el-button>
							<el-button @click="resetQuery(ruleFormRef)" v-waves class="default-button" :loading="gridOptions.loading">
								<SvgIcon name="ele-Refresh" class="mr5" />重置
							</el-button>
						</el-form-item>
					</el-form>
				</template>
				<template #toolbar_buttons>
					<el-button
						type="primary"
						@click="onAuditMultiple"
						:disabled="isChecked"
						:loading="gridOptions.loading"
						v-auth="'business:special:audit:multiple'"
						>批量审批<span v-if="checkTable.length">({{ checkTable.length }})</span>
					</el-button>
				</template>
				<template #statusText="{ row }">
					<el-text type="danger" tag="b" v-if="[1, 2, 3, 9, 101, 102, 103, 104, 105, 200].includes(row.order?.status)">{{
						row.order?.statusText
					}}</el-text>
					<span v-else>{{ row.order?.statusText }}</span>
				</template>
				<template #order_detail="{ row }">
					<order-detail :order="row.order" @updateList="refreshList">{{ row.order?.title }}</order-detail>
				</template>
				<template #action="{ row }">
					<el-button link type="primary" @click="onAudit(row)" title="审批特提" v-auth="'business:special:audit'" v-show="[0].includes(row.state)">
						审批
					</el-button>
					<el-button link type="primary" @click="onAuditDetail(row)" title="查看审批明细" v-if="[1, 2].includes(row.state)"> 审批明细 </el-button>
				</template>
				<template #pager>
					<pagination
						@pagination="queryList"
						:total="state.total"
						v-model:current-page="state.queryParams.PageIndex"
						v-model:page-size="state.queryParams.PageSize"
						:disabled="gridOptions.loading"
					/>
				</template>
			</vxe-grid>
		</div>
		<!-- 特提审批 -->
		<special-audit ref="specialAuditRef" @updateList="refreshList" />
		<!-- 审批详情 -->
		<special-audit-detail ref="specialAuditDetailRef" />
		<!-- 批量审批 -->
		<special-audit-multiple ref="specialAuditMultipleRef" @updateList="refreshList" />
	</div>
</template>
<script setup lang="tsx" name="orderSpecialAudit">
import { computed, defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { specialList } from '@/api/business/special';
// 引入组件
const SpecialAudit = defineAsyncComponent(() => import('@/views/business/special/components/Special-audit.vue')); // 审批
const SpecialAuditMultiple = defineAsyncComponent(() => import('@/views/business/special/components/Special-audit-multiple.vue')); // 批量审批
const SpecialAuditDetail = defineAsyncComponent(() => import('@/views/business/special/components/Special-audit-detail.vue')); // 审批详情
const OrderDetail = defineAsyncComponent(() => import('@/components/OrderDetail/index.vue')); // 工单详情
const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页
// 定义变量内容
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive({
	queryParams: {
		// 查询条件
		PageIndex: 1,
		PageSize: 20,
		Keyword: null, // 关键字
		State: 0, // 审核结果 0 待审核 1 审核通过 2 审核不通过
		SortField: null, // 排序字段
		SortRule: null, // 排序规则 0 升序 1 降序
	},
	tableData: [], //表单
	loading: false, // 加载
	total: 0, // 总数
});
const gridOptions = reactive<any>({
	loading: false,
	border: true,
	showOverflow: true,
	columnConfig: {
		resizable: true,
	},
	scrollY: {
		enabled: true,
		gt: 100,
	},
	toolbarConfig: {
		zoom: true,
		custom: true,
		refresh: {
			queryMethod: () => {
				handleQuery();
			},
		},
		slots: {
			buttons: 'toolbar_buttons',
		},
	},
	customConfig: {
		storage: true,
	},
	id: 'orderSpecialAudit',
	rowConfig: { isHover: true, height: 30, isCurrent: true, useKey: true },
	height: 'auto',
	columns: [
		{ type: 'checkbox', width: 50, align: 'center' },
		{
			field: 'order.expiredStatusText',
			title: '状态',
			width: 60,
			align: 'center',
			slots: {
				default: ({ row }) => {
					return <span class={'overdue-status-' + row.order?.expiredStatus} title={row.order.expiredStatusText}></span>;
				},
			},
		},
		{
			field: 'order.statusText',
			title: '工单状态',
			width: 100,
			slots: {
				default: 'statusText',
			},
		},
		{ field: 'order.no', title: '工单编码', width: 140 },
		{ field: 'order.title', title: '工单标题', minWidth: 200, slots: { default: 'order_detail' } },
		{ field: 'order.sourceChannel', title: '来源渠道', width: 110 },
		{ field: 'order.hotspotName', title: '热点分类', width: 150 },
		{ field: 'order.acceptorName', title: '受理人', width: 120 },
		{ field: 'order.orgLevelOneName', title: '一级部门', width: 140 },
		{ field: 'stateText', title: '特提审批状态', width: 140 },
		{ field: 'cause', title: '特提原因', width: 150 },
		{ field: 'creatorName', title: '申请人', width: 140 },
		{ field: 'creatorOrgName', title: '申请部门', width: 140 },
		{ field: 'reason', title: '申请理由', minWidth: 150 },
		{
			title: '操作',
			fixed: 'right',
			width: 100,
			align: 'center',
			slots: { default: 'action' },
		},
	],
	data: [],
	sortConfig: {
		remote: true,
	},
});
const gridEvents = {
	sortChange(val: any) {
		state.queryParams.SortField = val.order ? val.field : null;
		// 0 升序 1 降序
		state.queryParams.SortRule = val.order ? (val.order == 'desc' ? 1 : 0) : null;
		handleQuery();
	},
};
// 手动查询，将页码设置为1
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
// 刷新列表
const refreshList = () => {
	queryList();
};
/** 获取列表 */
const queryList = () => {
	gridOptions.loading = true;
	specialList(state.queryParams)
		.then((res) => {
			gridOptions.data = res.result?.items ?? [];
			state.total = res.result?.total ?? 0;
			gridOptions.loading = false;
			gridRef.value.clearCheckboxRow();
			checkTable.value = [];
		})
		.catch((err) => {
			console.log(err);
			gridOptions.loading = false;
			gridRef.value.clearCheckboxRow();
			checkTable.value = [];
		});
};

/** 重置按钮操作 */
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 审批
const specialAuditRef = ref<RefType>();
const onAudit = (row: any) => {
	specialAuditRef.value.openDialog(row);
};
// 审批详情
const specialAuditDetailRef = ref<RefType>();
const onAuditDetail = (row: any) => {
	specialAuditDetailRef.value.openDialog(row.id ?? '');
};
// 批量审批
const specialAuditMultipleRef = ref<RefType>();
const onAuditMultiple = () => {
	const ids = checkTable.value.map((item: any) => item.id);
	specialAuditMultipleRef.value.openDialog(ids);
};
const checkTable = ref<EmptyArrayType>([]);
const gridRef = ref<RefType>();
const selectAllChangeEvent = ({ checked }) => {
	if (gridRef.value) {
		const records = gridRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '所有勾选事件' : '所有取消事件', records);
	}
};

const selectChangeEvent = ({ checked }) => {
	if (gridRef.value) {
		const records = gridRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '勾选事件' : '取消事件', records);
	}
};
const isChecked = computed(() => {
	return !checkTable.value.length;
});
onMounted(() => {
	queryList();
});
</script>
